#include <stdio.h>
#include <stdlib.h>

#define CLR_STDIN() while(getchar() != '\n'){}

/// Calculate kinetic energy of object
///
/// *e - pointer to store calculated energy in
/// m  - mass of object, must be greater than 0
/// v  - velocity of object
///
/// Returns 1 on success, 0 on failure
int calculate_kinetic_energy(float *e, float m, float v) {
  // cannot have negative mass
  if (m <= 0.0) return 0;

  *e = 0.5 * m * v * v;

  return 1;
}

int main() {
  int rc;
  float e, m = 0.0, v = 0.0;

  do {
    printf("Enter mass of object: ");
    rc = scanf("%f", &m);
    CLR_STDIN();
    if (rc != 1) {
      continue;
    }
  } while (m <= 0.0);

  do {
    printf("Enter velocity of object: ");
    rc = scanf("%f", &v);
    CLR_STDIN();
    if (rc != 1) {
      continue;
    }
    break;
  } while (1);

  rc = calculate_kinetic_energy(&e, m, v);
  if (rc != 1) {
    printf("calculate_kinetic_energy failed\n");
    return -1;
  }

  printf("Kinetic energy: %.3f kJ\n", e/1000);

  return 0;
}
